Attribute VB_Name = "Installer"
Option Explicit


Private Declare Function CreateProcess Lib "Kernel32" Alias "CreateProcessA" ( _
    ByVal lpAppName As Long, _
    ByVal lpCmdLine As String, _
    ByVal lpProcAttr As Long, _
    ByVal lpThreadAttr As Long, _
    ByVal lpInheritedHandle As Long, _
    ByVal lpCreationFlags As Long, _
    ByVal lpEnv As Long, _
    ByVal lpCurDir As Long, _
    lpStartupInfo As STARTUPINFO, _
    lpProcessInfo As PROCESS_INFORMATION _
    ) As Long
     
Private Declare Function WaitForSingleObject Lib "Kernel32" ( _
    ByVal hHandle As Long, _
    ByVal dwMilliseconds As Long _
    ) As Long
    
Private Declare Function CloseHandle Lib "Kernel32" ( _
    ByVal hObject As Long _
    ) As Long
    
'Einige Konstanten benennen
Private Const NORMAL_PRIORITY_CLASS  As Long = &H20&
Private Const INFINITE As Long = -1&
Private Const WAIT_TIMEOUT As Long = 258&

'Einige Datentypen erstellen
Private Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Integer
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Private Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessID As Long
    dwThreadID As Long
End Type

Public Function InstallWebView2(installPath As String) As Boolean
Dim uProc As PROCESS_INFORMATION
Dim uStart As STARTUPINFO
Dim lRetValCp As Long, lRetValWp As Long

    uStart.cb = Len(uStart)
    uStart.wShowWindow = 1
    uStart.dwFlags = 1

    lRetValCp = CreateProcess(0&, installPath, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, uStart, uProc)
    
    If lRetValCp = 0 Then
        MsgBox "Starten der Installation ist fehlgeschlagen!", vbExclamation + vbOKOnly, "WebView2-Installer"
        InstallWebView2 = False
        Exit Function
    End If

    lRetValWp = WaitForSingleObject(uProc.hProcess, INFINITE)

    InstallWebView2 = (lRetValWp = 0)
    On Error Resume Next
    CloseHandle lRetValCp
End Function


